Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34921)
@@ -745,57 +1025,76 @@
             # (will only create the priority tag if it doesn't exist,
             #  others get changed only if they already exist)
-            if ($preferred{$tagInfo} or $tagInfo->{Table}{PREFERRED}) {
+            my $prf = defined $$tagInfo{Preferred} ? $$tagInfo{Preferred} : $$tagInfo{Table}{PREFERRED};
+            # hack to prefer only a single tag in the QuickTime group
+            if ($$tagInfo{Table}{GROUPS}{0} eq 'QuickTime') {
+                $prf = 0 if $tagPriority{$tagInfo} < $highestQT{$lcTag};
+            }
+            if ($$pref{$tagInfo} or $prf) {
                 if ($permanent or $shift) {
                     # don't create permanent or Shift-ed tag but define IsCreating
                     # so we know that it is the preferred tag
-                    $nvHash->{IsCreating} = 0;
-                } elsif (($tagInfo->{List} and not $options{DelValue}) or
-                         not ($nvHash->{DelValue} and @{$nvHash->{DelValue}}) or
+                    $$nvHash{IsCreating} = 0;
+                } elsif (($$tagInfo{List} and not $options{DelValue}) or
+                         not ($$nvHash{DelValue} and @{$$nvHash{DelValue}}) or
                          # also create tag if any DelValue value is empty ('')
-                         grep(/^$/,@{$nvHash->{DelValue}}))
+                         grep(/^$/,@{$$nvHash{DelValue}}))
                 {
-                    $nvHash->{IsCreating} = $options{EditOnly} ? 0 : ($options{EditGroup} ? 2 : 1);
+                    $$nvHash{IsCreating} = $editOnly ? 0 : ($editGroup ? 2 : 1);
                     # add to hash of groups where this tag is being created
                     $createGroups or $createGroups = $options{CreateGroups} || { };
                     $$createGroups{$self->GetGroup($tagInfo, 0)} = 1;
-                    $nvHash->{CreateGroups} = $createGroups;
-                }
-            }
-            if (%{$self->{DEL_GROUP}} and $nvHash->{IsCreating}) {
-                my ($grp, @grps);
-                foreach $grp (keys %{$self->{DEL_GROUP}}) {
-                    next if $self->{DEL_GROUP}{$grp} == 2;
-                    # set flag indicating tags were written after this group was deleted
-                    $self->{DEL_GROUP}{$grp} = 2;
-                    push @grps, $grp;
-                }
-                if ($verbose > 1 and @grps) {
-                    @grps = sort @grps;
-                    print $out "  Writing new tags after deleting groups: @grps\n";
-                }
+                    $$nvHash{CreateGroups} = $createGroups;
+                }
+            }
+            if ($$nvHash{IsCreating}) {
+                if (%{$$self{DEL_GROUP}}) {
+                    my ($grp, @grps);
+                    foreach $grp (keys %{$$self{DEL_GROUP}}) {
+                        next if $$self{DEL_GROUP}{$grp} == 2;
+                        # set flag indicating tags were written after this group was deleted
+                        $$self{DEL_GROUP}{$grp} = 2;
+                        push @grps, $grp;
+                    }
+                    if ($verbose > 1 and @grps) {
+                        @grps = sort @grps;
+                        print $out "  Writing new tags after deleting groups: @grps\n";
+                    }
+                }
+            } elsif ($createOnly) {
+                $noCreate = $permanent ? 'permanent' : ($$tagInfo{Avoid} ? 'avoided' : '');
+                $noCreate or $noCreate = $shift ? 'shifting' : 'not preferred';
+                $verbose > 2 and print $out "Not creating $wgrp1:$tag ($noCreate)\n";
+                next;   # nothing to do (not creating and not editing)
             }
             if ($shift or not $options{DelValue}) {
-                $nvHash->{Value} or $nvHash->{Value} = [ ];
-                if (not $tagInfo->{List}) {
+                $$nvHash{Value} or $$nvHash{Value} = [ ];
+                if (not $$tagInfo{List}) {
                     # not a List tag -- overwrite existing value
-                    $nvHash->{Value}[0] = $val;
+                    $$nvHash{Value}[0] = $val;
+                } elsif (defined $$nvHash{AddBefore} and @{$$nvHash{Value}} >= $$nvHash{AddBefore}) {
+                    # values from a later argument have been added (ie. Replace=0)
+                    # to this list, so the new values should come before these
+                    splice @{$$nvHash{Value}}, -$$nvHash{AddBefore}, 0, ref $val eq 'ARRAY' ? @$val : $val;
                 } else {
-                    # add to existing list
-                    push @{$nvHash->{Value}}, ref $val eq 'ARRAY' ? @$val : $val;
+                    # add at end of existing list
+                    push @{$$nvHash{Value}}, ref $val eq 'ARRAY' ? @$val : $val;
                 }
                 if ($verbose > 1) {
-                    my $ifExists = $nvHash->{IsCreating} ?
-                                  ($nvHash->{IsCreating} == 2 ? " if $writeGroup exists" : '') :
-                                  (($nvHash->{DelValue} and @{$nvHash->{DelValue}}) ?
-                                   ' if tag was deleted' : ' if tag exists');
-                    my $verb = ($shift ? 'Shifting' : ($options{AddValue} ? 'Adding' : 'Writing'));
+                    my $ifExists = $$nvHash{IsCreating} ? ( $createOnly ?
+                                  ($$nvHash{IsCreating} == 2 ?
+                                    " if $writeGroup exists and tag doesn't" :
+                                    " if tag doesn't exist") :
+                                  ($$nvHash{IsCreating} == 2 ? " if $writeGroup exists" : '')) :
+                                  (($$nvHash{DelValue} and @{$$nvHash{DelValue}}) ?
+                                    ' if tag was deleted' : ' if tag exists');
+                    my $verb = ($shift ? 'Shifting' : ($addValue ? 'Adding' : 'Writing'));
                     print $out "$verb $wgrp1:$tag$ifExists\n";
                 }
             }
         } elsif ($permanent) {
-            $err = "Can't delete $wgrp1:$tag";
+            $err = "Can't delete Permanent tag $wgrp1:$tag";
             $verbose > 1 and print $out "$err\n";
             next;
-        } elsif ($options{AddValue} or $options{DelValue}) {
+        } elsif ($addValue or $options{DelValue}) {
             $verbose > 1 and print $out "Adding/Deleting nothing does nothing\n";
             next;
@@ -804,34 +1103,44 @@
             $self->GetNewValueHash($tagInfo, $writeGroup, 'delete');
             my $nvHash = $self->GetNewValueHash($tagInfo, $writeGroup, 'create');
-            $nvHash->{WantGroup} = $wantGroup;
+            $$nvHash{WantGroup} = $wantGroup;
             $verbose > 1 and print $out "Deleting $wgrp1:$tag\n";
         }
+        $$setTags{$tagInfo} = 1 if $setTags;
+        $prioritySet = 1 if $$pref{$tagInfo};
+WriteAlso:
         ++$numSet;
-        $$setTags{$tagInfo} = 1 if $setTags;
-        $prioritySet = 1 if $preferred{$tagInfo};
-WriteAlso:
         # also write related tags
         my $writeAlso = $$tagInfo{WriteAlso};
         if ($writeAlso) {
-            my ($wtag, $n);
+            my ($wgrp, $wtag, $n);
+            if ($$tagInfo{WriteGroup} and $$tagInfo{WriteGroup} eq 'All' and $writeGroup) {
+                $wgrp = $writeGroup . ':';
+            } else {
+                $wgrp = '';
+            }
             local $SIG{'__WARN__'} = \&SetWarning;
             foreach $wtag (keys %$writeAlso) {
                 my %opts = (
                     Type => 'ValueConv',
-                    Protected => $protected | 0x02,
-                    AddValue => $options{AddValue},
-                    DelValue => $options{DelValue},
-                    CreateGroups => $createGroups,
-                    SetTags => \%alsoWrote, # remember tags already written
+                    Protected   => $protected | 0x02,
+                    AddValue    => $addValue,
+                    DelValue    => $options{DelValue},
+                    Shift       => $options{Shift},
+                    Replace     => $options{Replace},   # handle lists properly
+                    CreateGroups=> $createGroups,
+                    SetTags     => \%alsoWrote,         # remember tags already written
                 );
                 undef $evalWarning;
                 #### eval WriteAlso ($val)
-                my $v = eval $writeAlso->{$wtag};
+                my $v = eval $$writeAlso{$wtag};
+                # we wanted to do the eval in case there are side effect, but we
+                # don't want to write a value for a tag that is being deleted:
+                undef $v unless defined $val;
                 $@ and $evalWarning = $@;
                 unless ($evalWarning) {
-                    ($n,$evalWarning) = $self->SetNewValue($wtag, $v, %opts);
+                    ($n,$evalWarning) = $self->SetNewValue($wgrp . $wtag, $v, %opts);
                     $numSet += $n;
                     # count this as being set if any related tag is set
-                    $prioritySet = 1 if $n and $preferred{$tagInfo};
+                    $prioritySet = 1 if $n and $$pref{$tagInfo};
                 }
                 if ($evalWarning and (not $err or $verbose > 2)) {
@@ -851,14 +1160,35 @@
         warn "$err\n" if $err and not wantarray;
     } elsif (not $numSet) {
-        my $pre = $wantGroup ? ($ifdName || $wantGroup) . ':' : '';
+        my $pre = $wantGroup ? $wantGroup . ':' : '';
         if ($wasProtected) {
-            $err = "Tag '$pre$tag' is $wasProtected for writing";
-        } elsif ($foundMatch) {
-            $err = "Sorry, $pre$tag is not writable";
-        } else {
-            $err = "Tag '$pre$tag' does not exist";
-        }
-        $verbose > 2 and print $out "$err\n";
-        warn "$err\n" unless wantarray;
+            $verbose = 0;   # we already printed this verbose message
+            unless ($options{Replace} and $options{Replace} == 2) {
+                $err = "Sorry, $pre$tag is $wasProtected for writing";
+            }
+        } elsif (not $listOnly) {
+            if ($origTag =~ /[?*]/) {
+                if ($noCreate) {
+                    $err = "No tags matching 'pre${origTag}' will be created";
+                    $verbose = 0;   # (already printed)
+                } elsif ($foundMatch) {
+                    $err = "Sorry, no writable tags matching '$pre${origTag}'";
+                } else {
+                    $err = "No matching tags for '$pre${origTag}'";
+                }
+            } elsif ($noCreate) {
+                $err = "Not creating $pre$tag";
+                $verbose = 0;   # (already printed)
+            } elsif ($foundMatch) {
+                $err = "Sorry, $pre$tag is not writable";
+            } elsif ($wantGroup and @matchingTags) {
+                $err = "Sorry, $pre$tag doesn't exist or isn't writable";
+            } else {
+                $err = "Tag '$pre${tag}' is not defined";
+            }
+        }
+        if ($err) {
+            $verbose > 2 and print $out "$err\n";
+            warn "$err\n" unless wantarray;
+        }
     } elsif ($$self{CHECK_WARN}) {
         $err = $$self{CHECK_WARN};
@@ -888,5 +1218,5 @@
     local $_;
     my ($self, $srcFile, @setTags) = @_;
-    my $key;
+    my ($key, $tag, @exclude, @reqTags);
 
     # get initial SetNewValuesFromFile options
@@ -895,5 +1225,5 @@
         $_ = shift @setTags;
         foreach $key (keys %$_) {
-            $opts{$key} = $_->{$key};
+            $opts{$key} = $$_{$key};
         }
     }
@@ -901,7 +1231,14 @@
     @setTags and ExpandShortcuts(\@setTags);
     my $srcExifTool = new Image::ExifTool;
-    my $options = $self->{OPTIONS};
+    # set flag to indicate we are being called from inside SetNewValuesFromFile()
+    $$srcExifTool{TAGS_FROM_FILE} = 1;
+    # synchronize and increment the file sequence number
+    $$srcExifTool{FILE_SEQUENCE} = $$self{FILE_SEQUENCE}++;
     # set options for our extraction tool
-    $srcExifTool->{TAGS_FROM_FILE} = 1;
+    my $options = $$self{OPTIONS};
+    # copy both structured and flattened tags by default (but flattened tags are "unsafe")
+    my $structOpt = defined $$options{Struct} ? $$options{Struct} : 2;
+    # copy structures only if no tags specified (since flattened tags are "unsafe")
+    $structOpt = 1 if $structOpt eq '2' and not @setTags;
     # +------------------------------------------+
     # ! DON'T FORGET!!  Must consider each new   !
@@ -909,30 +1246,77 @@
     # +------------------------------------------+
     $srcExifTool->Options(
-        Binary      => 1,
-        Charset     => $$options{Charset},
-        CharsetID3  => $$options{CharsetID3},
-        CharsetIPTC => $$options{CharsetIPTC},
-        CharsetPhotoshop => $$options{CharsetPhotoshop},
-        Composite   => $$options{Composite},
-        CoordFormat => $$options{CoordFormat} || '%d %d %.8f', # copy coordinates at high resolution unless otherwise specified
-        DateFormat  => $$options{DateFormat},
-        Duplicates  => 1,
-        Escape      => $$options{Escape},
+        Binary          => 1,
+        Charset         => $$options{Charset},
+        CharsetEXIF     => $$options{CharsetEXIF},
+        CharsetFileName => $$options{CharsetFileName},
+        CharsetID3      => $$options{CharsetID3},
+        CharsetIPTC     => $$options{CharsetIPTC},
+        CharsetPhotoshop=> $$options{CharsetPhotoshop},
+        Composite       => $$options{Composite},
+        CoordFormat     => $$options{CoordFormat} || '%d %d %.8f', # copy coordinates at high resolution unless otherwise specified
+        DateFormat      => $$options{DateFormat},
+        Duplicates      => 1,
+        Escape          => $$options{Escape},
+      # Exclude (set below)
+        ExtendedXMP     => $$options{ExtendedXMP},
         ExtractEmbedded => $$options{ExtractEmbedded},
-        FastScan    => $$options{FastScan},
-        FixBase     => $$options{FixBase},
-        IgnoreMinorErrors => $$options{IgnoreMinorErrors},
-        Lang        => $$options{Lang},
-        LargeFileSupport => $$options{LargeFileSupport},
-        List        => 1,
-        MakerNotes  => 1,
+        FastScan        => $$options{FastScan},
+        Filter          => $$options{Filter},
+        FixBase         => $$options{FixBase},
+        GlobalTimeShift => $$options{GlobalTimeShift},
+        HexTagIDs       => $$options{HexTagIDs},
+        IgnoreMinorErrors=>$$options{IgnoreMinorErrors},
+        Lang            => $$options{Lang},
+        LargeFileSupport=> $$options{LargeFileSupport},
+        List            => 1,
+        ListItem        => $$options{ListItem},
+        ListSep         => $$options{ListSep},
+        MakerNotes      => $$options{FastScan} && $$options{FastScan} > 1 ? undef : 1,
+        MDItemTags      => $$options{MDItemTags},
         MissingTagValue => $$options{MissingTagValue},
-        Password    => $$options{Password},
-        PrintConv   => $$options{PrintConv},
-        ScanForXMP  => $$options{ScanForXMP},
-        StrictDate  => 1,
-        Struct      => ($$options{Struct} or not defined $$options{Struct}) ? 1 : 0,
-        Unknown     => $$options{Unknown},
+        NoPDFList       => $$options{NoPDFList},
+        Password        => $$options{Password},
+        PrintConv       => $$options{PrintConv},
+        QuickTimeUTC    => $$options{QuickTimeUTC},
+        RequestAll      => $$options{RequestAll} || 1, # (is this still necessary now that RequestTags are being set?)
+        RequestTags     => $$options{RequestTags},
+        SaveFormat      => $$options{SaveFormat},
+        SavePath        => $$options{SavePath},
+        ScanForXMP      => $$options{ScanForXMP},
+        StrictDate      => defined $$options{StrictDate} ? $$options{StrictDate} : 1,
+        Struct          => $structOpt,
+        SystemTags      => $$options{SystemTags},
+        TimeZone        => $$options{TimeZone},
+        Unknown         => $$options{Unknown},
+        UserParam       => $$options{UserParam},
+        Validate        => $$options{Validate},
+        XAttrTags       => $$options{XAttrTags},
+        XMPAutoConv     => $$options{XMPAutoConv},
     );
+    $$srcExifTool{GLOBAL_TIME_OFFSET} = $$self{GLOBAL_TIME_OFFSET};
+    foreach $tag (@setTags) {
+        next if ref $tag;
+        if ($tag =~ /^-(.*)/) {
+            # avoid extracting tags that are excluded
+            push @exclude, $1;
+            next;
+        }
+        # add specified tags to list of requested tags
+        $_ = $tag;
+        if (/(.+?)\s*(>|<)\s*(.+)/) {
+            if ($2 eq '>') {
+                $_ = $1;
+            } else {
+                $_ = $3;
+                /\$/ and push(@reqTags, /\$\{?(?:[-\w]+:)*([-\w?*]+)/g), next;
+            }
+        }
+        push @reqTags, $2 if /(^|:)([-\w?*]+)#?$/;
+    }
+    if (@exclude) {
+        ExpandShortcuts(\@exclude, 1);
+        $srcExifTool->Options(Exclude => \@exclude);
+    }
+    $srcExifTool->Options(RequestTags => \@reqTags) if @reqTags;
     my $printConv = $$options{PrintConv};
     if ($opts{Type}) {
@@ -948,9 +1332,8 @@
     my $info = $srcExifTool->ImageInfo($srcFile);
     return $info if $$info{Error} and $$info{Error} eq 'Error opening file';
-    delete $srcExifTool->{VALUE}{Error};  # delete so we can check this later
+    delete $$srcExifTool{VALUE}{Error}; # delete so we can check this later
 
     # sort tags in reverse order so we get priority tag last
     my @tags = reverse sort keys %$info;
-    my $tag;
 #
 # simply transfer all tags from source image if no tags specified
@@ -958,10 +1341,10 @@
     unless (@setTags) {
         # transfer maker note information to this object
-        $self->{MAKER_NOTE_FIXUP} = $srcExifTool->{MAKER_NOTE_FIXUP};
-        $self->{MAKER_NOTE_BYTE_ORDER} = $srcExifTool->{MAKER_NOTE_BYTE_ORDER};
+        $$self{MAKER_NOTE_FIXUP} = $$srcExifTool{MAKER_NOTE_FIXUP};
+        $$self{MAKER_NOTE_BYTE_ORDER} = $$srcExifTool{MAKER_NOTE_BYTE_ORDER};
         foreach $tag (@tags) {
             # don't try to set errors or warnings
             next if $tag =~ /^(Error|Warning)\b/;
-            # get approprite value type if necessary
+            # get appropriate value type if necessary
             if ($opts{SrcType} and $opts{SrcType} ne $srcType) {
                 $$info{$tag} = $srcExifTool->GetValue($tag, $opts{SrcType});
@@ -969,5 +1352,5 @@
             # set value for this tag
             my ($n, $e) = $self->SetNewValue($tag, $$info{$tag}, %opts);
-            # delete this tag if we could't set it
+            # delete this tag if we couldn't set it
             $n or delete $$info{$tag};
         }
@@ -978,10 +1361,10 @@
 #
     # 1) loop through input list of tags to set, and build @setList
-    my (@setList, $set, %setMatches);
-    foreach (@setTags) {
-        if (ref $_ eq 'HASH') {
+    my (@setList, $set, %setMatches, $t);
+    foreach $t (@setTags) {
+        if (ref $t eq 'HASH') {
             # update current options
-            foreach $key (keys %$_) {
-                $opts{$key} = $_->{$key};
+            foreach $key (keys %$t) {
+                $opts{$key} = $$t{$key};
             }
             next;
@@ -990,6 +1373,6 @@
         # (also use this hash to store expression and wildcard flags, EXPR and WILD)
         my $opts = { %opts };
-        $tag = lc($_);  # change tag/group names to all lower case
-        my ($fam, $grp, $dst, $dstGrp, $dstTag, $isExclude);
+        $tag = lc $t;   # change tag/group names to all lower case
+        my (@fg, $grp, $dst, $dstGrp, $dstTag, $isExclude);
         # handle redirection to another tag
         if ($tag =~ /(.+?)\s*(>|<)\s*(.+)/) {
@@ -998,5 +1381,5 @@
             if ($2 eq '>') {
                 ($tag, $dstTag) = ($1, $3);
-                # flag add and delete (ie. '+<' and '-<') redirections
+                # flag add and delete (eg. '+<' and '-<') redirections
                 $opt = $1 if $tag =~ s/\s*([-+])$// or $dstTag =~ s/^([-+])\s*//;
             } else {
@@ -1005,35 +1388,37 @@
                 # handle expressions
                 if ($tag =~ /\$/) {
-                    $tag = $_;  # restore original case
+                    $tag = $t;  # restore original case
                     # recover leading whitespace (except for initial single space)
                     $tag =~ s/(.+?)\s*(>|<) ?//;
                     $$opts{EXPR} = 1; # flag this expression
-                    $grp = '';
                 } else {
                     $opt = $1 if $tag =~ s/^([-+])\s*//;
                 }
             }
+            # validate tag name(s)
+            $$opts{EXPR} or ValidTagName($tag) or $self->Warn("Invalid tag name '${tag}'"), next;
+            ValidTagName($dstTag) or $self->Warn("Invalid tag name '${dstTag}'"), next;
             # translate '+' and '-' to appropriate SetNewValue option
             if ($opt) {
                 $$opts{{ '+' => 'AddValue', '-' => 'DelValue' }->{$opt}} = 1;
-                $$opts{Shift} = 0;  # shift if this is a date/time tag
+                $$opts{Shift} = 0;  # shift if shiftable
             }
             ($dstGrp, $dstTag) = ($1, $2) if $dstTag =~ /(.*):(.+)/;
             # ValueConv may be specified separately on the destination with '#'
             $$opts{Type} = 'ValueConv' if $dstTag =~ s/#$//;
-            # ignore leading family number
-            $dstGrp = $2 if $dstGrp =~ /^(\d+)(.*)/ and $1 < 2;
-            # replace 'all' with '*' in tag and group names
+            # replace tag name of 'all' with '*'
             $dstTag = '*' if $dstTag eq 'all';
-            $dstGrp = '*' if $dstGrp eq 'all';
         }
         unless ($$opts{EXPR}) {
             $isExclude = ($tag =~ s/^-//);
-            if ($tag =~ /^([-\w]*?|\*):(.+)/) {
+            if ($tag =~ /(.*):(.+)/) {
                 ($grp, $tag) = ($1, $2);
-                # separate leading family number
-                ($fam, $grp) = ($1, $2) if $grp =~ /^(\d+)(.*)/;
-            } else {
-                $grp = '';  # flag for don't care about group
+                foreach (split /:/, $grp) {
+                    # save family/groups in list (ignoring 'all' and '*')
+                    next unless length($_) and /^(\d+)?(.*)/;
+                    my ($f, $g) = ($1, $2);
+                    $f = 7 if $g =~ s/^ID-//i;
+                    push @fg, [ $f, $g ] unless $g eq '*' or $g eq 'all';
+                }
             }
             # allow ValueConv to be specified by a '#' on the tag name
@@ -1044,29 +1429,17 @@
             # replace 'all' with '*' in tag and group names
             $tag = '*' if $tag eq 'all';
-            $grp = '*' if $grp eq 'all';
-            # allow wildcards in tag names
+            # allow wildcards in tag names (handle differently from all tags: '*')
             if ($tag =~ /[?*]/ and $tag ne '*') {
-                $$opts{WILD} = 1;   # set flag indicating wildcards were used
+                $$opts{WILD} = 1;   # set flag indicating wildcards were used in source tag
                 $tag =~ s/\*/[-\\w]*/g;
                 $tag =~ s/\?/[-\\w]/g;
             }
         }
-        # redirect, exclude or set this tag (Note: $grp is '' if we don't care)
+        # redirect, exclude or set this tag (Note: @fg is empty if we don't care about the group)
         if ($dstTag) {
             # redirect this tag
             $isExclude and return { Error => "Can't redirect excluded tag" };
-            if ($dstTag ne '*') {
-                if ($dstTag =~ /[?*]/) {
-                    if ($dstTag eq $tag) {
-                        $dstTag = '*';
-                    } else {
-                        return { Error => "Invalid use of wildcards in destination tag" };
-                    }
-                } elsif ($tag eq '*') {
-                    return { Error => "Can't redirect from all tags to one tag" };
-                }
-            }
             # set destination group the same as source if necessary
-          # (removed in 7.72 so '-xmp:*>*:*' will preserve XMP family 1 groups)
+          # (removed in 7.72 so '-*:*<xmp:*' will preserve XMP family 1 groups)
           # $dstGrp = $grp if $dstGrp eq '*' and $grp;
             # write to specified destination group/tag
@@ -1074,16 +1447,15 @@
         } elsif ($isExclude) {
             # implicitly assume '*' if first entry is an exclusion
-            unshift @setList, [ undef, '*', '*', [ '', '*' ], $opts ] unless @setList;
+            unshift @setList, [ [ ], '*', [ '', '*' ], $opts ] unless @setList;
             # exclude this tag by leaving $dst undefined
         } else {
-            $dst = [ $grp, $$opts{WILD} ? '*' : $tag ]; # copy to same group
-        }
-        $grp or $grp = '*';     # use '*' for any group
+            $dst = [ $grp || '', $$opts{WILD} ? '*' : $tag ]; # use same group name for dest
+        }
         # save in reverse order so we don't set tags before an exclude
-        unshift @setList, [ $fam, $grp, $tag, $dst, $opts ];
+        unshift @setList, [ \@fg, $tag, $dst, $opts ];
     }
     # 2) initialize lists of matching tags for each setTag
     foreach $set (@setList) {
-        $$set[3] and $setMatches{$set} = [ ];
+        $$set[2] and $setMatches{$set} = [ ];
     }
     # 3) loop through all tags in source image and save tags matching each setTag
@@ -1098,12 +1470,12 @@
         my $lcTag = lc(GetTagName($tag));
         my (@grp, %grp);
-        foreach $set (@setList) {
+SET:    foreach $set (@setList) {
             # check first for matching tag
-            unless ($$set[2] eq $lcTag or $$set[2] eq '*') {
+            unless ($$set[1] eq $lcTag or $$set[1] eq '*') {
                 # handle wildcards
-                next unless $$set[4]{WILD} and $lcTag =~ /^$$set[2]$/;
+                next unless $$set[3]{WILD} and $lcTag =~ /^$$set[1]$/;
             }
             # then check for matching group
-            unless ($$set[1] eq '*') {
+            if (@{$$set[0]}) {
                 # get lower case group names if not done already
                 unless (@grp) {
@@ -1111,12 +1483,16 @@
                     $grp{$_} = 1 foreach @grp;
                 }
-                # handle leading family number
-                if (defined $$set[0]) {
-                    next unless $grp[$$set[0]] and $$set[1] eq $grp[$$set[0]];
-                } else {
-                    next unless $grp{$$set[1]};
-                }
-            }
-            last unless $$set[3];   # all done if we hit an exclude
+                foreach (@{$$set[0]}) {
+                    my ($f, $g) = @$_;
+                    if (not defined $f) {
+                        next SET unless $grp{$g};
+                    } elsif ($f == 7) {
+                        next SET unless IsSameID($srcExifTool->GetTagID($tag), $g);
+                    } else {
+                        next SET unless defined $grp[$f] and $g eq $grp[$f];
+                    }
+                }
+            }
+            last unless $$set[2];   # all done if we hit an exclude
             # add to the list of tags matching this setTag
             push @{$setMatches{$set}}, $tag;
@@ -1126,17 +1502,17 @@
     foreach $set (reverse @setList) {
         # get options for SetNewValue
-        my $opts = $$set[4];
+        my $opts = $$set[3];
         # handle expressions
         if ($$opts{EXPR}) {
-            my $val = $srcExifTool->InsertTagValues(\@tags, $$set[2], 'Error');
-            unless (defined $val) {
-                # return warning if one of the tags didn't exist
-                $tag = NextTagKey(\%rtnInfo, 'Warning');
-                $rtnInfo{$tag} = $srcExifTool->GetValue('Error');
-                delete $srcExifTool->{VALUE}{Error};
-                next;
-            }
-            my ($dstGrp, $dstTag) = @{$$set[3]};
-            $$opts{Protected} = 1;
+            my $val = $srcExifTool->InsertTagValues(\@tags, $$set[1], 'Error');
+            if ($$srcExifTool{VALUE}{Error}) {
+                # pass on any error as a warning
+                $tag = NextFreeTagKey(\%rtnInfo, 'Warning');
+                $rtnInfo{$tag} = $$srcExifTool{VALUE}{Error};
+                delete $$srcExifTool{VALUE}{Error};
+                next unless defined $val;
+            }
+            my ($dstGrp, $dstTag) = @{$$set[2]};
+            $$opts{Protected} = 1 unless $dstTag =~ /[?*]/ and $dstTag ne '*';
             $$opts{Group} = $dstGrp if $dstGrp;
             my @rtnVals = $self->SetNewValue($dstTag, $val, %$opts);
@@ -1151,18 +1527,22 @@
                 $val = $$info{$tag};
             }
-            my ($dstGrp, $dstTag) = @{$$set[3]};
+            my ($dstGrp, $dstTag) = @{$$set[2]};
             if ($dstGrp) {
-                if ($dstGrp eq '*') {
-                    $dstGrp = $srcExifTool->GetGroup($tag, 1);
+                my @dstGrp = split /:/, $dstGrp;
+                # destination group of '*' writes to same group as source tag
+                # (family 1 unless otherwise specified)
+                foreach (@dstGrp) {
+                    next unless /^(\d*)(all|\*)$/i;
+                    $_ = $1 . $srcExifTool->GetGroup($tag, length $1 ? $1 : 1);
                     $noWarn = 1;    # don't warn on wildcard destinations
                 }
-                $$opts{Group} = $dstGrp;
+                $$opts{Group} = join ':', @dstGrp;
             } else {
                 delete $$opts{Group};
             }
             # transfer maker note information if setting this tag
-            if ($srcExifTool->{TAG_INFO}{$tag}{MakerNotes}) {
-                $self->{MAKER_NOTE_FIXUP} = $srcExifTool->{MAKER_NOTE_FIXUP};
-                $self->{MAKER_NOTE_BYTE_ORDER} = $srcExifTool->{MAKER_NOTE_BYTE_ORDER};
+            if ($$srcExifTool{TAG_INFO}{$tag}{MakerNotes}) {
+                $$self{MAKER_NOTE_FIXUP} = $$srcExifTool{MAKER_NOTE_FIXUP};
+                $$self{MAKER_NOTE_BYTE_ORDER} = $$srcExifTool{MAKER_NOTE_BYTE_ORDER};
             }
             if ($dstTag eq '*') {
